VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "draw_Rectangle"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' The PictureBox we draw on.
Public picGraph As PictureBox

' The rectangle's drawing attributes.
Public X1 As Single
Public Y1 As Single
Public X2 As Single
Public Y2 As Single
Public DrawWidth As Integer
Public ForeColor As OLE_COLOR
Public FillColor As OLE_COLOR
Public FillStyle As FillStyleConstants

' Default properties.
Private Const m_def_X1 = 0
Private Const m_def_Y1 = 0
Private Const m_def_X2 = 120
Private Const m_def_Y2 = 120
Private Const m_def_DrawWidth = 1
Private Const m_def_ForeColor = vbRed
Private Const m_def_FillColor = vbRed
Private Const m_def_FillStyle = vbFSTransparent

' True if the object is selected.
Public Selected As Boolean

' Draw on picGraph.
Public Sub Draw()
    ' See if the object is selected.
    If Selected Then
        ' It is selected.
        ' Draw in yellow to highlight it.
        picGraph.ForeColor = vbRed
    Else
        ' It is not selected.
        ' Use its normal ForeColor.
        picGraph.ForeColor = ForeColor
    End If

    ' Set other drawing attributes.
    With picGraph
        .FillStyle = FillStyle
        .FillColor = FillColor
        .DrawWidth = DrawWidth
    End With

    ' Draw the object.
    picGraph.Line (X1, Y1)-(X2, Y2), picGraph.ForeColor, B
End Sub
' Return the object's serialization.
Public Property Get Serialization() As String
Dim txt As String

    ' Build the serialization.
    If X1 <> m_def_X1 Then txt = txt & "X1(" & Format$(X1) & ")"
    If Y1 <> m_def_Y1 Then txt = txt & "Y1(" & Format$(Y1) & ")"
    If X2 <> m_def_X2 Then txt = txt & "X2(" & Format$(X2) & ")"
    If Y2 <> m_def_Y2 Then txt = txt & "Y2(" & Format$(Y2) & ")"
    If DrawWidth <> m_def_DrawWidth Then txt = txt & "DrawWidth(" & Format$(DrawWidth) & ")"
    If ForeColor <> m_def_ForeColor Then txt = txt & "ForeColor(" & Format$(ForeColor) & ")"
    If FillColor <> m_def_FillColor Then txt = txt & "FillColor(" & Format$(FillColor) & ")"
    If FillStyle <> m_def_FillStyle Then txt = txt & "FillStyle(" & Format$(FillStyle) & ")"

    Serialization = "Rectangle(" & txt & ")"
End Property


' Return True if the object is at this position.
Public Function IsAt(ByVal X As Single, ByVal Y As Single) As Boolean
    IsAt = (X1 <= X And X2 >= X And _
            Y1 <= Y And Y2 >= Y)
End Function


' Set default property values.
Private Sub SetDefaultProperties()
    X1 = m_def_Y1
    Y1 = m_def_X1
    X2 = m_def_Y2
    Y2 = m_def_X2
    DrawWidth = m_def_DrawWidth
    ForeColor = m_def_ForeColor
    FillColor = m_def_FillColor
    FillStyle = m_def_FillStyle
    Selected = False
End Sub

' Set some defaults.
Private Sub Class_Initialize()
    SetDefaultProperties
End Sub

